/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#include <clack/c/packet.h>
#include <netinet/ip.h>
#include <arpa/inet.h> /* htonl */

extern struct in_addr mask;
extern struct in_addr addr;
extern struct in_addr gateway;

static struct in_addr _mask;

clack_error_t init(void) 
{
        _mask.s_addr = htonl(mask.s_addr);
        return 0;
}

int pred(clack_packet_t *p)
{
	struct in_addr dst;

	dst.s_addr = ((struct ip*)clack_packet_data(p))->ip_dst.s_addr;
        if (((dst.s_addr ^ addr.s_addr) & _mask.s_addr) == 0) {
                memcpy(&p->anno.next_hop,&gateway,sizeof(p->anno.next_hop));
                return 1;
        } else {
                return 0;
        }
}
